
import socket

SOCKET_IP = 0
SOCKET_PORT = 1
SOCKET_ADDRESS = 4

LOCAL_ADDRESSES = [u'localhost', u'127.0.0.1']


def get_local_interface_addresses():
    return [interface[SOCKET_ADDRESS][SOCKET_IP]
            for interface in socket.getaddrinfo(socket.gethostname(), None)]


def get_public_interface_addresses():
    return [interface[SOCKET_ADDRESS][SOCKET_IP]
            for interface in socket.getaddrinfo(socket.getfqdn(), None)]


def get_local_hostname():
    return socket.gethostname()


def get_public_hostname():
    return socket.getfqdn()


def get_my_addresses():

    addresses = list()

    # Add local to addresses
    addresses.append(LOCAL_ADDRESSES)

    # Add all my interface IP's to addresses
    addresses.append(get_local_interface_addresses())

    # Add my hostname to addresses
    addresses.append(get_local_hostname())

    # Add all my public interface IP's to addresses
    addresses.append(get_public_interface_addresses())

    # Add my public hostname to addresses
    addresses.append(get_public_hostname())

    return addresses
